/*
 * Created on 18-sep-2007
 */
package be.ASPL.presentationlayer;

/**
 * The PresentationName valuegetter extracts the name of the current presentation from the user Function.
 * 
 * @author Erwin Smout
 */
class ArchitectureValueGetterForPresentationName extends ArchitectureValueGetter {

	/**
	 * The instance
	 */
	private static ArchitectureValueGetter instance = new ArchitectureValueGetterForPresentationName();

	/**
	 * Gets The instance
	 * 
	 * @return The instance
	 */
	static ArchitectureValueGetter getInstance ( ) {
		return instance;
	}

	/**
	 * 
	 */
	private ArchitectureValueGetterForPresentationName ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.ArchitectureValueGetter#getValue(be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction)
	 */
	String getValue (OnLinePresentationFunction userFunction) {
		return userFunction.getPresentation().getName();
	}
}
