package be.ASPL.presentationlayer;

import java.util.Date;

/**
 * @author Erwin
 */
public final class TimeValue implements PresentationValue {

	/**
	 * The date value
	 */
	private Date dateTime;

	/**
	 * @param d
	 *            -
	 */
	public TimeValue (Date d) {
		dateTime = d;
	}

	/**
	 * @param tm
	 *            -
	 */
	public TimeValue (long tm) {
		dateTime = new Date(tm);
	}

	/**
	 * Gets The date value
	 * 
	 * @return The date value
	 */
	public Date getDateTime ( ) {
		return dateTime;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString ( ) {
		return dateTime.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.WaarValue#toWAARString(be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public String toASPLString (UserData userData) {
		return userData.getPreferredTimeFormat().format(dateTime);
	}
}
