package be.ASPL.webclient;

import be.ASPL.presentationlayer.*;

import java.util.*;

/**
 *
 */
public class UsersManageDetailsPresentation extends Presentation {
	/**
	 * @return
	 * @throws ASPLException
	 */
	private static final java.util.List<PresentationField> getPresentationFieldDefs ( ) throws ASPLException {
		return Arrays.asList(new PresentationField[] { //
				new PresentationField("USERID", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, "", true, -1, PresentationFieldIOMode.IN, "", "", "inputtext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("PASSWORD", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, "", false, 20, PresentationFieldIOMode.IN, "", "", "inputtext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("LANGUAGE", be.ASPL.presentationlayer.UserLanguage.class, Locale.ENGLISH, "", true, 30, PresentationFieldIOMode.IN, "COMBOBOX", "", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("ROLES", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, "", false, 40, PresentationFieldIOMode.IN, "", "", "inputlongtext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("DISABLED", be.ASPL.presentationlayer.Logical.class, Locale.ENGLISH, "", false, -1, PresentationFieldIOMode.OUT, "", "20", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("PWCHANGEREQUIRED", be.ASPL.presentationlayer.Logical.class, Locale.ENGLISH, "", false, -1, PresentationFieldIOMode.OUT, "", "20", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
						, new PresentationField("PWFAILURES", be.ASPL.presentationlayer.List.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, "", "", "", getPresentationFieldsMap(new PresentationField[] { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ 
								new PresentationField("PASSWORDFAILURE", be.ASPL.presentationlayer.TimeStampType.class, Locale.ENGLISH, "", false, -1, PresentationFieldIOMode.OUT, "", "", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
								})) });
	}

	/**
	 *
	 */
	private static final java.util.List<String> ACTIONS = Arrays.asList(new String[] {});

	/**
	 * @throws ASPLException
	 *             -
	 */
	public UsersManageDetailsPresentation ( ) throws ASPLException {
		super(UsersManageDetailsPresentation.class.getSimpleName(), getPresentationFieldDefs(), ACTIONS);
	}
}
