/**
 * 
 */
package be.SIRAPRISE.birdwatcher;

import java.util.Date;

import be.SIRAPRISE.client.jsba.*;
import be.SIRAPRISE.typeimplementations.*;

/**
 * @author Erwin
 * 
 */
@Relvars(relvarNames = { RELVARNAMES.WALK })
public final class Walk extends AbstractUpdatableDBObject {

	/**
	 * 
	 */
	private Walk preUpdateState;

	/**
	 * 
	 */
	private Date walkDate;

	/**
	 * Creates the Walk
	 */
	public Walk ( ) {

	}

	/**
	 * Creates the Walk
	 * 
	 * @param walkDate
	 *            -
	 */
	public Walk (Date walkDate) {
		this.walkDate = walkDate;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#getPreUpdateState()
	 */
	@Override
	public UpdatableDBObject getPreUpdateState ( ) {
		return preUpdateState;
	}

	/**
	 * Gets walkDate
	 * 
	 * @return walkDate.
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = ATTRIBUTENAMES.WALKDATE, requiresEscaping = false, typeName = TYPENAMES.DATE) }, relvarNames = { RELVARNAMES.WALK })
	public final Date getWalkDate ( ) {
		return walkDate;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#setPreUpdateState()
	 */
	@Override
	public final void setPreUpdateState ( ) {
		this.preUpdateState = new Walk(walkDate);
	}

	/**
	 * Sets walkDate
	 * 
	 * @param walkDate
	 *            The walkDate to set.
	 */
	public final void setWalkDate (Date walkDate) {
		this.walkDate = walkDate;
	}

	/**
	 * Sets walkDate
	 * 
	 * @param walkDate
	 *            The walkDate to set.
	 */
	@AttributeDef(attributeName = ATTRIBUTENAMES.WALKDATE, requiresEscaping = false, typeName = TYPENAMES.DATE)
	public final void setWalkDate (ValueBuffer walkDate) {
		setWalkDate(DbmsDateImplementation.getJavaDate(walkDate));
	}

}
