package be.SIRAPRISE.birdwatcher;

import be.ASPL.presentationlayer.*;

import java.util.*;

/**
 *
 */
public class WalksOverviewPresentation extends Presentation {
	/**
	 * @return
	 * @throws ASPLException
	 */
	private static final java.util.List<PresentationField> getPresentationFieldDefs ( ) throws ASPLException {
		return Arrays.asList(new PresentationField[] { //
				new PresentationField("WALKDATE", be.ASPL.presentationlayer.DateType.class, Locale.ENGLISH, null, false, 10, PresentationFieldIOMode.IN, null, "", "inputshorttext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
						, new PresentationField("FROMDATE", be.ASPL.presentationlayer.DateType.class, Locale.ENGLISH, null, false, 20, PresentationFieldIOMode.IN, null, "", "inputshorttext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
						, new PresentationField("TODATE", be.ASPL.presentationlayer.DateType.class, Locale.ENGLISH, null, false, 25, PresentationFieldIOMode.IN, null, "", "inputshorttext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
						, new PresentationField("SPECIESNAME", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, null, false, 30, PresentationFieldIOMode.IN, null, "", "inputlongtext", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
						, new PresentationField("LANGUAGE", be.ASPL.presentationlayer.UserLanguage.class, Locale.ENGLISH, null, false, 70, PresentationFieldIOMode.IN, "COMBOBOX", "20", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ 
						, new PresentationField("WALKSLIST", be.ASPL.presentationlayer.List.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, null, "", "", getPresentationFieldsMap(new PresentationField[] { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
								new PresentationField("WALKDATE", be.ASPL.presentationlayer.DateType.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, null, "", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
										, new PresentationField("SPOTTEDSPECIESLIST", be.ASPL.presentationlayer.List.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, null, "", "", getPresentationFieldsMap(new PresentationField[] { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
												new PresentationField("SPECIESNAME", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, null, "", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
														, new PresentationField("NLANNOTATEDNAME", be.ASPL.presentationlayer.StringType.class, Locale.ENGLISH, null, false, -1, PresentationFieldIOMode.OUT, null, "", "", null) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
												})) })) });
	}

	/**
	 *
	 */
	private static final java.util.List<String> ACTIONS = Arrays.asList(new String[] {});

	/**
	 * @throws ASPLException
	 *             -
	 */
	public WalksOverviewPresentation ( ) throws ASPLException {
		super("WalksOverviewPresentation", getPresentationFieldDefs(), ACTIONS); //$NON-NLS-1$ 
	}
}
