/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

/**
 * TextOnlyTestResultDetails
 * 
 * @author erwin
 * 
 */
final class TextOnlyTestResultDetails extends TestResultDetails {

	/**
	 * 
	 */
	private String text;

	/**
	 * Creates the TextOnlyTestResultDetails
	 * 
	 * @param text
	 */
	TextOnlyTestResultDetails (String text) {
		this.text = text;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return text;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
