/*
 * Created on 18-sep-2007
 */
package be.ASPL.presentationlayer;

/**
 * The NextRowStyleClassName valuegetter allows for alternating table row styles. The getValue method alternates the return value over the set of row style class names set for the user function (currently fixed at "tr1" and "tr2").
 * 
 * @author Erwin Smout
 */
class ArchitectureValueGetterForNextRowStyleClassName extends ArchitectureValueGetter {

	/**
	 * The instance
	 */
	private static ArchitectureValueGetter instance = new ArchitectureValueGetterForNextRowStyleClassName();

	/**
	 * Gets The instance
	 * 
	 * @return The instance
	 */
	static ArchitectureValueGetter getInstance ( ) {
		return instance;
	}

	/**
	 * 
	 */
	private ArchitectureValueGetterForNextRowStyleClassName ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.ArchitectureValueGetter#getValue(be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction)
	 */
	String getValue (OnLinePresentationFunction userFunction) {
		return userFunction.getNextRowStyleClassName(0);
	}
}
