package be.ASPL.presentationlayer;

/**
 * @author Erwin
 */
public final class IntegerValue implements PresentationValue {

	/**
	 * the value
	 */
	private int integer;

	/**
	 * @param i
	 *            -
	 */
	public IntegerValue (int i) {
		integer = i;
	}

	/**
	 * Gets the value
	 * 
	 * @return the value
	 */
	public int getInteger ( ) {
		return integer;
	}

	public String toString ( ) {
		return Integer.toString(integer);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.WaarValue#toWAARString(be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public String toASPLString (UserData userData) {
		return Integer.toString(integer);
	}
}
