package be.ASPL.presentationlayer;

/**
 * @author Erwin
 */
public final class LongIntegerValue implements PresentationValue {

	/**
	 * the value
	 */
	private long longinteger;

	/**
	 * @param l
	 *            -
	 */
	public LongIntegerValue (long l) {
		longinteger = l;
	}

	/**
	 * Gets the value
	 * 
	 * @return the value
	 */
	public long getLonginteger ( ) {
		return longinteger;
	}

	public String toString ( ) {
		return Long.toString(longinteger);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.WaarValue#toWAARString(be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public String toASPLString (UserData userData) {
		return Long.toString(longinteger);
	}
}
